/**
 * Defines the behavior of the editing form for a vplquestion.
 * @copyright  Astor Bizard, 2019
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define("qtype_vplquestion/editform",["jquery","jqueryui","core/log","qtype_vplquestion/vplservice","qtype_vplquestion/codeeditors","qtype_vplquestion/scriptsloader"],(function($,jqui,log,VPLService,CodeEditors,ScriptsLoader){function updateEditorContent(aceEditor,newContent){aceEditor.getSession().setValue(newContent),aceEditor.getSession().setUndoManager(new ace.UndoManager)}function updateExecfilesVisibility(){var selectedVpl=$("#id_templatevpl").val()>"",showPrecheckExecfiles="diff"==$("#id_precheckpreference").val();$(".novplmessage").toggle(!selectedVpl),$("#execfileslist, #fitem_id_execfile").toggle(selectedVpl),$("#fitem_id_precheckexecfileslist").toggle(showPrecheckExecfiles),$("#precheckexecfileslist, #fitem_id_precheckexecfile").toggle(selectedVpl&&showPrecheckExecfiles),$("#ace_placeholder_precheckexecfile").length&&ace.edit("ace_placeholder_precheckexecfile").resize()}function applyTemplateChoice(keepContents){var selectedVpl=$("#id_templatevpl").val();$("#fitem_id_templatecontext").toggle(selectedVpl>""),updateExecfilesVisibility(),selectedVpl&&(VPLService.call("info","reqfile",selectedVpl).then((function(reqfile){var lang=VPLService.langOfFile(reqfile.name);$(".code-editor:not(.manylangs) .ace-placeholder").each((function(){ace.edit(this).getSession().setMode("ace/mode/"+lang)})),$("[name=templatelang]").val(lang),keepContents||updateEditorContent(ace.edit("ace_placeholder_templatecontext"),reqfile.contents)})).fail((function(message){log.error(message,"Error retrieving required files info for VPL "+selectedVpl)})),VPLService.call("info","execfiles",selectedVpl).then((function(execfiles){setupExecfiles(execfiles=execfiles.filter((function(execfile){return!["vpl_run.sh","vpl_debug.sh","vpl_evaluate.sh","pre_vpl_run.sh"].includes(execfile.name)})),keepContents,"#execfileslist","ace_placeholder_execfile",$("[name=execfiles]")),setupExecfiles(execfiles,keepContents,"#precheckexecfileslist","ace_placeholder_precheckexecfile",$("[name=precheckexecfiles]"))})).fail((function(message){log.error(message,"Error retrieving execution files info for VPL "+selectedVpl)})))}function setupExecfiles(execfiles,keepContents,fileTabs,placeholder,$hiddenField){var aceEditor=ace.edit(placeholder),$fileTabs=$(fileTabs).html(""),execfilesObj={},initialContents=$hiddenField.val().length>0?JSON.parse($hiddenField.val()):{};execfiles.forEach((function(execfile){var content;content=VPLService.isBinary(execfile.name)?"UNUSED":keepContents&&initialContents[execfile.name]||execfile.contents,execfilesObj[execfile.name]=content,$fileTabs.append('<li class="execfilename float-left"><span class="clickable rounded-top'+(content.startsWith("UNUSED")?" unused":"")+'">'+execfile.name+"</span></li>")})),$hiddenField.val(JSON.stringify(execfilesObj)),$(fileTabs+" .execfilename span").click((function(event){$(this).is(".currentfile")||updateExecfile($(fileTabs+" .currentfile"),$(this),aceEditor,$hiddenField),event.preventDefault()})),$("input[type=submit]").click((function(){storeExecfile($(fileTabs+" .currentfile").text(),aceEditor.getValue(),$hiddenField)})),updateExecfile(null,$(fileTabs+" .execfilename span").first(),aceEditor,$hiddenField)}function storeExecfile(fileName,fileContent,$hiddenField){var execfiles=JSON.parse($hiddenField.val());execfiles[fileName]=fileContent,$hiddenField.val(JSON.stringify(execfiles))}function updateExecfile($prevFile,$newFile,aceEditor,$hiddenField){var prevFileContent=aceEditor.getValue();null!==$prevFile&&($prevFile.removeClass("currentfile"),$prevFile.toggleClass("unused",prevFileContent.startsWith("UNUSED")),storeExecfile($prevFile.text(),prevFileContent,$hiddenField)),$newFile.addClass("currentfile");var newFile=$newFile.text();VPLService.isBinary(newFile)?0==$(".qvpl-binary-file").length&&($(aceEditor.container).parent().addClass("invisible"),$("<pre>").addClass("qvpl-binary-file visible bg-white text-center h-100 p-3 position-relative").css("z-index","1").text(M.util.get_string("binaryfile","mod_vpl")).appendTo($(aceEditor.container))):($(".qvpl-binary-file").remove(),$(aceEditor.container).parent().removeClass("invisible"),aceEditor.getSession().setMode("ace/mode/"+VPLService.langOfFile(newFile))),updateEditorContent(aceEditor,JSON.parse($hiddenField.val())[newFile])}return{setup:function(templateChangeHelpButton,vplVersion){CodeEditors.setupFormEditors().done((function(){ScriptsLoader.loadVPLUtil(vplVersion,(function(){var helpButton,$templateSelect,templateChangeMessage,$templateChangeDialog;applyTemplateChoice(!0),helpButton=templateChangeHelpButton,$templateSelect=$("#id_templatevpl"),templateChangeMessage=M.util.get_string("templatevplchangeprompt","qtype_vplquestion")+helpButton,$templateChangeDialog=$('<div class="py-3">'+templateChangeMessage+"</div>").dialog({autoOpen:!1,dialogClass:"vplchangedialog p-3 bg-white",title:M.util.get_string("templatevplchange","qtype_vplquestion"),closeOnEscape:!1,modal:!0,buttons:[{text:M.util.get_string("overwrite","qtype_vplquestion"),class:"btn btn-primary mx-1",click:function(){$templateSelect.data("current",$templateSelect.val()),$(this).dialog("close"),applyTemplateChoice(!1)}},{text:M.util.get_string("merge","qtype_vplquestion"),class:"btn btn-primary mx-1",click:function(){$templateSelect.data("current",$templateSelect.val()),$(this).dialog("close"),applyTemplateChoice(!0)}},{text:M.util.get_string("cancel","moodle"),class:"btn btn-secondary mx-1",click:function(){$templateSelect.val($templateSelect.data("current")),$(this).dialog("close")}}],open:function(){$(".vplchangedialog").focus()}}),$templateSelect.focus((function(){$(this).data("current",$(this).val())})).change((function(){$templateSelect.val()&&""!=$("[name=execfiles]").val()?$templateChangeDialog.dialog("open"):($templateSelect.data("current",$templateSelect.val()),applyTemplateChoice(!1))})),$("#id_precheckpreference").change(updateExecfilesVisibility)}))}))}}}));

//# sourceMappingURL=editform.min.js.map